/******************************************************************************
 * 
 *   This file is part of LC1 - Load Control application 1, by Sven Ruin.
 *   
 ******************************************************************************/

#ifndef _FPM_UFPTLC1_H
#define _FPM_UFPTLC1_H

// -------------------------------------------------------------------
// includes go here.
// -------------------------------------------------------------------
#include "standard.h"
#include "FPM_Variable.h"
#include "FPM_Starter.h"
#include "FPM_ApplicationProperties.h"


using namespace std;

using namespace SmartServer::FPM_LIB_VERSION;
using namespace FPM;

//-------------------------------------------------------------------
// ==> FPM module unique name
//-------------------------------------------------------------------
#define FPM_MODULE_NAME  "#9FFD030000001000[5].UFPTLC1"

namespace _9FFD030000001000_5__UFPTLC1_APP
{

// -------------------------------------------------------------------
//   class:  CUFPTLC1
// -------------------------------------------------------------------
class CUFPTLC1 : public CFPM_App, public TSingleton<CUFPTLC1>
{
  // -----------------------------------------------------------------
  //  Constructor / Destructor
  // -----------------------------------------------------------------
  protected:
    CUFPTLC1::CUFPTLC1();
    ~CUFPTLC1();


  // -----------------------------------------------------------------
  //   Implements the user functionality
  // -----------------------------------------------------------------
  public:
    // Initialization and Cleanup
    virtual void Initialize();
    virtual void Shutdown();

    // User implemented methods
    virtual void Work();
    virtual void OnTimer();
    //void OnMyTimer();

  // -----------------------------------------------------------------
  //   Utility Methods
  // -----------------------------------------------------------------
  public:

  // -----------------------------------------------------------------
  //   Internals
  // -----------------------------------------------------------------
  // -----------------------------------------------------------------
  //   Module Startup/Shutdown Methods
  // -----------------------------------------------------------------
  public:
    STATUS StartModule(const char* pszModuleName);
    STATUS StopModule(const char* pszModuleName);
  // -----------------------------------------------------------------
  //   Mandatory Application Members
  // -----------------------------------------------------------------
  private:
    friend class FPM::TSingleton<CUFPTLC1>;
    static CUFPTLC1 *m_pSingleton;

    // Sven's code - begin
    CFPM_Timer m_oTimer1;  // declare a timer
    // Sven's code - end

    //CFPM_Timer m_oTimer2;
};


#define START_TIMER(timerVar, mode, timeoutMillis, funcName)  \
  timerVar.Start<CUFPTLC1>( mode, timeoutMillis, this, &CUFPTLC1::funcName );
/*
#define START_TIMER2(timerVar, mode, timeoutMillis, instance, className, funcName)  \
  timerVar.Start<className>( mode, timeoutMillis, instance, &className::funcName );
*/

template <typename T>
Variable<T>* DeclareVariable(const char* pszCppType, const char* pszName, const enum FPM_DpDirection eDirection, 
    const char* pszFptKey, const char* pszFbUrl, const char* pszDpRefType/*, int nPollrate = 500*/)
{
  Variable<T>* p = new Variable<T>( ToILonFormat( pszCppType ).c_str(), pszName, eDirection );
  (*CUFPTLC1::GetSingleton()->m_pDeclaredVariables).insert( NameToVariableMap_t::value_type( pszName, p ) );
  return (Variable<T>*) (*CUFPTLC1::GetSingleton()->m_pDeclaredVariables->find( pszName )).second;
}

} // namespace _9FFD030000001000_5__UFPTLC1_APP

#endif // _FPM_UFPTLC1_H
